<?php

function display_personal_material_issue_header_details($pmi_no, $pmrt_no) {
    global $approval_statuses, $systypes_array;
    
    $pmi_hd_row = get_job_material_issue_header($pmi_no);
    
    $user_id = $_SESSION['wa_current_user']->user;
    $cap = can_access_project($pmi_hd_row['project_id'], $user_id);
        if ($cap['success'] !== true) {
            display_error($cap["message"]);
            display_footer_exit();
            exit;
        }
        
    display_heading($systypes_array[ST_PERSONAL_MATERIAL_ISSUE]." Header");
    
        $issue_trans_no = $pmi_hd_row['trans_no'];
        $_POST['location_name'] = $pmi_hd_row['location_name'];
        $_POST['loc_code'] = $pmi_hd_row['loc_code'];
        hidden('loc_code', $pmi_hd_row['loc_code']);
        if (! isset($_POST['employee_code']) && ! ($pmrt_no > 0)) {
            $_POST['employee_code'] = $pmi_hd_row['employee_code'];
        }
    
    start_outer_table(TABLESTYLE2, "width=65%"); // outer table
        start_table(TABLESTYLE2);  
            table_section(1, "27%");
                label_row("Issue Trans #:", get_inventory_trans_view_str($pmi_hd_row['type'], $pmi_hd_row['trans_no'])); 
                label_row("Job Card:", get_service_trans_view_str(ST_JOB_ORDER, $pmi_hd_row['jo_id'])); 
                label_row("Reference:", $pmi_hd_row['reference']);  

            table_section(2, "45%");
                label_row("Project:", get_project_formatted_name($pmi_hd_row['project_id']));  
                label_row("Date:", sql2date($pmi_hd_row['tran_date']));  
                label_row("Received By:", get_employee_formatted_long_name($pmi_hd_row['employee_code']));  
                
            table_section(3, "27%");
                label_row("Location:", $pmi_hd_row['location_name']);  
                label_row("Requestor:", $pmi_hd_row['requestor_name']);  
                $s = get_project_trans_view_str(ST_APPROVAL_LOG, $issue_trans_no."&source_type_id=".ST_PERSONAL_MATERIAL_ISSUE, "Approval Status");
                label_row($s, $approval_statuses[$pmi_hd_row['approval_status']]);

    end_outer_table(2); // outer table
    
    if (strlen($pmi_hd_row['comments']) > 0) {
        start_table(TABLESTYLE);
            label_row("Comment:", nl2br($pmi_hd_row['comments']));  
        end_table(2);
    }
    
    return $pmi_hd_row;
}

function display_personal_material_return_header($pmrt_no, $pmi_hd_row) {
    global $Refs, $systypes_array;
    
    display_heading($systypes_array[ST_PERSONAL_MATERIAL_RETURN]." Header");
    
        $type = ST_PERSONAL_MATERIAL_RETURN;
        $trans_no = 0;
    
        $_POST['project_id'] = $pmi_hd_row['project_id'];
        hidden('project_id', $pmi_hd_row['project_id']);

        $user_id = $_SESSION['wa_current_user']->user;
        $cap = can_access_project($_POST['project_id'], $user_id);
            if($cap['success'] !== true) {
                display_error($cap["message"]);
                set_focus('project_id');
                display_footer_exit();
                exit;
            }  
            
        $header = get_job_material_issue_header($pmrt_no);

        if (is_array($header)) {
            
            $trans_no = $header['trans_no'];

            if (! isset($_POST['reference'])) {
                $_POST['reference'] = $header['reference'];
            }

            if (! isset($_POST['comments'])){
                $_POST['comments'] = $header['comments'];
            }        

            if (! isset($_POST['tran_date'])) {
                $_POST['tran_date'] = sql2date($header['tran_date']);
            }

            if (! isset($_POST['employee_code'])) {
                $_POST['employee_code'] = $header['employee_code'];
            }

            if (! isset($_POST['approval_status'])) {
                $_POST['approval_status'] = $header['approval_status'];
            }

        } else {
            $_POST['reference'] = $Refs->get_next($type);            
            $_POST['approval_status'] = 0;
        }

        div_start('nsit_header');
  
            start_outer_table(TABLESTYLE2, "width=65%"); // outer table
                start_table(TABLESTYLE2);  
                    table_section(1, "50%");

                        if (is_array($header)) {
                            label_row("Trans #:", get_inventory_trans_view_str($header['type'], $header['trans_no']));  
                            
                            $reference = $header['reference'];            
                            text_row("Reference:", 'reference', $reference, null, null);            
                        } else {            
                            text_row("Reference:", 'reference', $Refs->get_next($type), null, null);   
                        }
                        
                        date_row("Date:", "tran_date");
                        label_row("Location:", $_POST['location_name']);

                    table_section(2, "50%");
                        
                        start_cell("colspan=2");
                            start_table(false, 'align=left');
                                employee_search_list_row(_("Employee:"). spaces(6), 'employee_code', null, false, true);
                            end_table();
                        end_cell();
                        textarea_row("Comment:", 'comments', null, 45, 2); 

                        global $approval_statuses;
                        $s = get_project_trans_view_str(ST_APPROVAL_LOG, $trans_no."&source_type_id=".$type, "Approval Status");
                        label_row($s, $approval_statuses[$_POST['approval_status']]);

            end_outer_table(2); // outer table
    
        div_end();
}

function display_personal_material_return_details($pmi_no, $pmrt_no) { 
    global $Ajax, $daily_item_types_array, $systypes_array;
    
    display_heading($systypes_array[ST_PERSONAL_MATERIAL_RETURN]." Details");
    
    $issue_trans_no = $return_trans_no = 0;
    $trnsfr_header = get_job_material_issue_header_record($pmi_no);
        if (is_array($trnsfr_header)) {
            $issue_trans_no = $trnsfr_header['trans_no'];
        } 
        
    $return_hd_row = get_job_material_issue_header_record($pmrt_no);
        if (is_array($return_hd_row)) {
            $return_trans_no = $return_hd_row['trans_no'];
        } 
        
    $units_array = build_all_item_units_array();
    
    $Ajax->activate('nsit_details');
    div_start('nsit_details');
    
        start_table(TABLESTYLE, "width=95%");

            $th = array(_("Issue Line"), _("Return Line"), _("Item Type"), _("Item"), _("Trn. Unit"), _("Trn.Qty"), _('Returned'), _('Returned Alloc'), _('Remain'), 
                        _('Return Unit'), _('Return Qty'), _('Budget'), _('Site'), _('Line Comment'), _(""), _(""), (""));  
                
            table_header($th);

            $k = 0; $dec = 4;
                $result = get_personal_material_issue_lines_with_persoanal_material_return_details($issue_trans_no, $return_trans_no);      
                    while ($row = db_fetch($result)) {
                        $id = $row['trans_id'];
                        $return_line_id = $row['return_line_id'];
                        
                        alt_table_row_color($k);

                            label_cell($id, 'align=center');
                            label_cell($return_line_id, 'align=center');
                            label_cell($daily_item_types_array[$row['item_type']]);
                            label_cell($row['stock_id'].' - '.$row['item_description']);
                            label_cell(text_bold($row['unit_name']));
                            qty_cell($row["tran_qty"], true, $dec);
                            
                            $trnfr_conversion_factor = $row['conversion_factor'];
                            qty_cell($row["returned_quantity"] / $trnfr_conversion_factor, false, $dec);
                            qty_cell($row["returned_alloc"] / $trnfr_conversion_factor, false, $dec);
                            qty_cell($row["tran_qty"] - (($row["returned_quantity"] + $row["returned_alloc"]) / $trnfr_conversion_factor), false, $dec);
                            
                            if (! isset($_POST["return_tran_unit_$id"])) {
                                if ($return_line_id > 0) {
                                    $_POST["return_tran_unit_$id"] = $row["return_tran_unit"];
                                } else {
                                    $_POST["return_tran_unit_$id"] = $row["tran_unit"];
                                }
                            }
                            
                            if ($row['item_type'] == NSIT_NON_STOCK_ITEM || $row['item_type'] == NSIT_STOCK_ITEM) {
                                units_list_cells('', "return_tran_unit_$id", $row['stock_id'], null, '', true);
                            } else {
                                custom_values_list_cells('', "return_tran_unit_$id", $units_array, null, '', true);   
                            }
                            
                            if (! isset($_POST["return_tran_qty_$id"])) {
                                if ($return_line_id > 0) {
                                    $_POST["return_tran_qty_$id"] = $row["return_tran_qty"];
                                } else {
                                    set_personal_material_return_remain_qty($id, $row, $dec);
                                }
                            } else {
                                if (list_updated("return_tran_unit_$id")) {
                                    set_personal_material_return_remain_qty($id, $row, $dec);
                                }
                            }
                            amount_cells("", "return_tran_qty_$id", null, null, null, $dec);
                            
                            label_cell($row['task_description']);
                            
                            if (! isset($_POST["site_id_$id"]) && ! ($return_line_id > 0)) {
                                $_POST["site_id_$id"] = $row['project_site_id'];
                            } elseif (! isset($_POST["site_id_$id"]) && $return_line_id > 0) {
                                $_POST["site_id_$id"] = $row['return_project_site_id'];
                            }
                            all_project_sites_list_cells("", "site_id_$id", GLOBAL_VOTES, null, '', false); 
                            
                            if (! isset($_POST["line_comment_$id"])) {
                                $_POST["line_comment_$id"] = $row['return_line_comment'];
                            }
                            text_cells('', "line_comment_$id", null, 20, 200, 'Line Comment');
                            
                            if ($return_line_id > 0 && $row['stock_control_method'] == SKCM_LOTS) {
                                $issue_convesion_factor = 1;
                                get_convertion_factor2($row["stock_id"], $_POST["return_tran_unit_$id"], $issue_convesion_factor);
                                
                                display_lot_serial_edit_cells($row['stock_control_method'], ST_PERSONAL_MATERIAL_RETURN, $return_trans_no, $return_line_id, 
                                                              $issue_convesion_factor, $dec);
                            } else {
                                label_cell('');
                            }
                            
                            if (! isset($_POST["checked_$id"]) && $return_line_id > 0) {
                                $_POST["checked_$id"] = 1;
                            } 
                            check_cells(null, "checked_$id", null, false, false, 'align=center colspan=2');

                        end_row();    
                        
                        vertical_space('height=18px colspan=17');
                    }
                    
        end_table(2);
    
    div_end();
}

function set_personal_material_return_remain_qty($id, $row, $dec=4) {
    $convesion_factor = 1;
    get_convertion_factor2($row['stock_id'], $_POST["return_tran_qty_$id"], $convesion_factor);
    $total_return_qty = $row["returned_quantity"] + $row["returned_alloc"];

    $remain_tran_qty = ($row["qty"] - $total_return_qty) / $convesion_factor;

    $_POST["return_tran_qty_$id"] = number_format($remain_tran_qty, $dec);
}

function can_save_personal_material_return_header($pmi_no, $pmrt_no) {
    global $Refs, $systypes_array;
    
    $trn_hd = get_job_material_issue_header_record($pmi_no);
        if (is_array($trn_hd)) {
            if ($trn_hd['type'] != ST_PERSONAL_MATERIAL_ISSUE) {
                return array("success" => false, "message" => "Invalid transaction type.");
            }
            if (! in_array($trn_hd['approval_status'], array(AS_APPROVED, AS_COMPLETED))) {
                return array("success" => false, "message" => $systypes_array[ST_PERSONAL_MATERIAL_ISSUE]." #$pmi_no is not approved/ completed.");
            } 
        } else {
            return array("success" => false, "message" => $systypes_array[ST_PERSONAL_MATERIAL_ISSUE]." #$pmi_no has been deleted by another user.");
        }
        
    $trans_no = $return_row_state = 0;
    $issue_row_state = $trn_hd['row_state'];
    $header = get_job_material_issue_header_record($pmrt_no);
    
    if (($pmrt_no > 0) && ! is_array($header)) {
        return array("success" => false, "message" => $systypes_array[ST_PERSONAL_MATERIAL_RETURN]." #$pmrt_no has been deleted by another user.");
    }
      
    if ($pmrt_no > 0) {
        if (! in_array($header['approval_status'], array(AS_NEW, AS_WITH_THE_APPROVER, AS_AWAITING_APPROVAL, AS_BACK_TO_ORIGINATOR))) {
            return array("success" => false, "message" => "This document status does not allow further updating.");
        }
        
        $ced_msg = can_edit_document($header['type'], $header['project_id'], $header['next_approval_group_id'], $_SESSION['wa_current_user']->user, $header['created_by']);
            if ($ced_msg['success'] !== true) {
                return array("success" => false, "message" => $ced_msg['message']);
            }
        
        $trans_no = $header['trans_no']; $return_row_state = $header['row_state'];
    }
    
    if (! $Refs->is_valid($_POST['reference'])) {
        return array("success" => false, "focus_to" => 'reference', "message" => "Please enter a reference.");      
    }    
 
    $ref_msg = reference_exists($_POST['reference'], ST_PERSONAL_MATERIAL_RETURN, $trans_no);
        if ($ref_msg) {
            return array("success" => false, "focus_to" => 'reference', "message" => $ref_msg);       
        }
      
    if (! is_date($_POST['tran_date'])) {
        return array("success" => false, "focus_to" => 'tran_date', "message" => "Date entered is not a valid date.");        
    }
      
    if (! (strlen($_POST['loc_code']) > 2)) {
        return array("success" => false, "focus_to" => 'loc_code', "message" => "From location cannot empty.");
    }
    
    if (isset($_POST['employee_code'])) {
        $emp_row = get_employee($_POST['employee_code']);
            if (! is_array($emp_row)) {
                return array('success' => false, "focus_to" => 'employee_code', 'message' => _("Please select an employee."));
            }
    } else {
        return array('success' => false, "focus_to" => 'employee_code', 'message' => _("Please select an employee."));
    }
    
    return array("success" => true, 'issue_row_state' => $issue_row_state, 'return_row_state' => $return_row_state, "message" => "", 'trn_hd' => $trn_hd);    
}

function can_save_personal_material_return_lines($issue_trans_no, $return_trans_no, $type, $loc_code, $process=false) {
    global $systypes_array;
    
    $result = get_personal_material_issue_lines_with_persoanal_material_return_details($issue_trans_no, $return_trans_no);  
        if (! (db_num_rows($result) > 0)) {
            return array('success' => false, 'message' => "No source ".$systypes_array[ST_PERSONAL_MATERIAL_ISSUE]." found.");
        }
        
        $check_exceeded_only = $process === false ? true : false;
        
        $no_selected_recs = 0;
        
        while ($row = db_fetch($result)) {
            $id = $row['trans_id'];
            $return_line_id = $row['return_line_id'];
            
            if (isset($_POST["checked_$id"]) && $_POST["checked_$id"] == 1) {
                $item_type = $row["item_type"];
                $stock_id = $row["stock_id"];
                $item_description = $row["item_description"];
                $return_tran_unit = $_POST["return_tran_unit_$id"];
                $return_tran_qty = input_num("return_tran_qty_$id");
                
                $convesion_factor = 1;
                
                // can save personal material return line
                $cn_sv_ln = can_save_personal_material_return_line($return_trans_no, $stock_id, $loc_code, $item_type, $item_description, $return_tran_unit, $return_tran_qty, 
                                                                   $convesion_factor, $return_line_id, $id, $row, $check_exceeded_only);
                    if ($cn_sv_ln['success'] !== true) {
                        return array("success" => false, "message" => $cn_sv_ln['message']);
                    }
                    
                $no_selected_recs++;
                    
            } else {
                
                if ($return_line_id > 0) {
                    $lot_row = get_lot_allocation_records($type, $return_trans_no, $return_line_id, fetch:true);
                        if (is_array($lot_row) > 0) {
                            return array("success" => false, "focus_to" => '', "message" => "Please delete all ".$systypes_array[ST_LOT_ALLOCATION]." details in ".
                                                                                             $systypes_array[$type]." Line #$return_line_id.");
                        }
                }
            }
        }
        
            if (! ($no_selected_recs > 0)) {
                return array("success" => false, "message" => "Please select at least one record before saving.");  
            }

        return array("success" => true, "message" => "");
}

function can_save_personal_material_return_line($trans_no, $stock_id, $loc_code, $item_type, $item_description, $return_tran_unit, $return_tran_qty, $convesion_factor, 
                                                $return_line_id, $id, $row, $check_exceeded_only=true) {
    $type = ST_PERSONAL_MATERIAL_RETURN;
    $dec = 4; 
    
    if (in_array($item_type, array(NSIT_NON_STOCK_ITEM, NSIT_STOCK_ITEM))) {
        if ($return_tran_unit == -1) {
            return array("success" => false, "focus_to" => "return_tran_unit_$id", "message" => "Issue Line #$id Please select a tran unit.");  
        }
    } elseif ($item_type == NSIT_COMMENT) {
        if (! (strlen($item_description) > 0)) {
            return array("success" => false, "focus_to" => "item_description_$id", "message" => "Issue Line #$id Item description cannot be empty.");  
        }
        
        if ($return_tran_unit == '0') {
            return array("success" => false, "focus_to" => "return_tran_unit_$id", "message" => "Issue Line #$id Please select a tran unit.");  
        }
    }
    
    if (! ($return_tran_qty > 0)) {
        return array("success" => false, "focus_to" => "return_tran_qty_$id", "message" => "Issue Line #$id Qty should be greater than zero.");  
    }

    get_convertion_factor2($stock_id, $return_tran_unit, $convesion_factor);
        
        $base_returned_qty = (float) get_job_material_issue_lines_total_by_source_line($type, $id, $return_line_id, approval_status_not_array: array(AS_REJECTED));
        $tran_returned_qty = $base_returned_qty / $convesion_factor;

        $total_tran_returned_qty = $tran_returned_qty + $return_tran_qty;

        $issued_tran_qty = ($row["qty"] / $convesion_factor);

        if ($total_tran_returned_qty > $issued_tran_qty) {
            $total_returnable_tran_qty = round($issued_tran_qty - $tran_returned_qty, $dec);
            $exceeded_qty = round($total_tran_returned_qty - $issued_tran_qty, $dec);

            return array("success" => false, "focus_to" => "return_tran_qty_$id", 
                         "message" => "Issued line #$id exceeded the maximum returnable qty of $total_returnable_tran_qty by $exceeded_qty qty in tran unit.");  
        }

        // check lot allocation exceeded
        if ($row['stock_control_method'] == SKCM_LOTS && $return_line_id > 0) {
            $data_arr = array('type' => $type, 'trans_no' => $trans_no, 'line_id' => $return_line_id, 'stock_id' => $stock_id, 'loc_code' => $loc_code, 
                              'conversion_factor' => $convesion_factor, 'tran_qty' => $return_tran_qty, 'tran_unit' => $return_tran_unit);
            $lot_ex_msg = check_total_lot_allocations_item_qty_exceed_allowable_qty($data_arr, $check_exceeded_only);
                if ($lot_ex_msg['success'] === false) {
                    if ($lot_ex_msg['exceeded'] === true) {
                        return array("success" => false, "message" => "Issue line #$return_line_id Issue Qty cannot smaller than total lot allcations."); 
                    } else {
                        return array("success" => false, "message" => "Issue line #$return_line_id Issue Qty cannot greater than total lot allcations."); 
                    }
                }
        }
                
        return array("success" => true, "focus_to" => "", "message" => ""); 
}

function save_personal_material_return_lines($issue_trans_no, $return_trans_no, $project_id, $loc_code, $tran_date, $process=false, $approval_status=0, $employee_code='') {
    global $systypes_array;
    $type = ST_PERSONAL_MATERIAL_RETURN;
    
    $result = get_personal_material_issue_lines_with_persoanal_material_return_details($issue_trans_no, $return_trans_no);  
    
    $return_lines_count = get_job_material_issue_details_lines_count($return_trans_no, $type, true);
        if ($return_lines_count > 0) {
            $del_af_rows = delete_job_material_issue_detail_lines($type, $return_trans_no, true);
                if ($del_af_rows != $return_lines_count) {
                    cancel_transaction();
                    return array('success' => false, 'message' => "Could not delete ".$systypes_array[$type]." detail lines.");
                }
        }
        
        while ($row = db_fetch($result)) {
            $id = $row['trans_id'];
            $return_line_id = $row['return_line_id'];
            
            if (isset($_POST["checked_$id"]) && $_POST["checked_$id"] == 1) {
                
                $return_tran_unit = $_POST["return_tran_unit_$id"];
                $return_tran_qty = input_num("return_tran_qty_$id");
                $site_id = $_POST["site_id_$id"];
                $line_comment = $_POST["line_comment_$id"];
                
                $convesion_factor = 1;
                
                // save personal material return line
                $sv_ln_msg = save_personal_material_return_line($type, $return_trans_no, $return_line_id, $loc_code, $tran_date, $row["item_type"], $row["stock_id"], 
                                                                $row["item_description"], $return_tran_unit, $return_tran_qty, $convesion_factor, $site_id, $line_comment, 
                                                                $row);
                    if ($sv_ln_msg['success'] !== true) {
                        cancel_transaction();
                        return array("success" => false, "message" => $sv_ln_msg['message']);
                    }
                    
                // process personal material returnn line 
                if ($process === true && $approval_status == AS_APPROVED) {
                    $stock_control_method = $row['stock_control_method'];
                    
                    $prs_msg = process_personal_material_return_line($type, $return_trans_no, $tran_date, $project_id, $return_line_id, $stock_control_method, $employee_code);
                        if ($prs_msg['success'] !== true) {
                            cancel_transaction();
                            return array("success" => false, "message" => $prs_msg['message']);
                        }
                } 
            } 
        }
        
        return array("success" => true, "message" => "");  
}

function save_personal_material_return_header(&$pmi_no, &$pmrt_no, &$return_trans_no, $type, $project_id, $reference, $tran_date, $loc_code, $employee_code, $comments, 
                                              $return_row_state, $jo_id) {
    global $systypes_array;
    
    $af_no = write_job_material_issue_header($type, $pmi_no, $pmrt_no, $return_trans_no, $reference, $project_id, $loc_code, $comments, $tran_date, $return_row_state, $jo_id,
                                             0, $employee_code); 
    
        if ($af_no > 0) {
            return array("success" => true, "message" => $systypes_array[$type]." header record #$pmrt_no has been saved.");
        } else {
            return array("success" => false, "message" => "Could not be saved ".$systypes_array[$type].' header.');
        }
}

function save_personal_material_return_line($type, $return_trans_no, &$return_line_id, $loc_code, $tran_date, $item_type, $stock_id, $item_description, $tran_unit, $tran_qty, 
                                            $conversion_factor, $site_id, $line_comment, $row) {    
    global $systypes_array;
    
        $id = $row['trans_id'];
        $standard_cost = $row['standard_cost'];
        $task_id = $row['task_id'];
                
            if ($item_type == NSIT_STOCK_ITEM) {
                $standard_cost = get_standard_cost($stock_id);
            } 
            
            get_convertion_factor2($stock_id, $tran_unit, $conversion_factor);

            $base_qty = $tran_qty * $conversion_factor;
            
            $ln_id = insert_job_material_issue_line($return_trans_no, $type, $loc_code, $tran_date, $stock_id, $item_type, $item_description, $tran_unit, $tran_qty, 
                                                    $base_qty, $conversion_factor, $standard_cost, $site_id, $line_comment, $task_id, $id, $return_line_id);
            
                if (! ($ln_id > 0)) {
                    return array("success" => false, "message" => "Could not save Issue  Line #$id ".$systypes_array[$type]." line details.");
                } 
        
                $return_line_id = $ln_id;
                
        return array("success" => true, "message" => $systypes_array[$type]." details have been saved.");
}

function save_personal_material_returns(&$pmi_no, &$pmrt_no, $process=false) {
    global $systypes_array;
    
    $issue_type = ST_PERSONAL_MATERIAL_ISSUE; $type = ST_PERSONAL_MATERIAL_RETURN;
    
    $cn_sv_hd = can_save_personal_material_return_header($pmi_no, $pmrt_no);   
        if ($cn_sv_hd["success"] !== true) {          
            return $cn_sv_hd;
        }
        
        $issue_row_state = $cn_sv_hd['issue_row_state']; $return_row_state = $cn_sv_hd['return_row_state'];
        
    $trnsfr_header = get_job_material_issue_header_record($pmi_no);
        $issue_trans_no = $trnsfr_header['trans_no']; $project_id = $trnsfr_header['project_id']; $pm_issue_ap = $trnsfr_header['approval_status'];
        $jo_id = $trnsfr_header['jo_id']; 
        
    $return_trans_no = $approval_status = 0; 
    $return_hd_row = get_job_material_issue_header_record($pmrt_no);
        if (is_array($return_hd_row)) {
            $return_trans_no = $return_hd_row['trans_no']; 
        }
        
    $cn_sv_line = can_save_personal_material_return_lines($issue_trans_no, $return_trans_no, $type, $_POST['loc_code'], $process);   
        if ($cn_sv_line["success"] !== true) {          
            return $cn_sv_line;
        }
        
    $tran_date = date2sql($_POST['tran_date']);
       
        begin_transaction();

            $hd_msg = save_personal_material_return_header($pmi_no, $pmrt_no, $return_trans_no, $type, $project_id, $_POST['reference'], $tran_date, $_POST['loc_code'], 
                                                           $_POST['employee_code'], $_POST['comments'], $return_row_state, $jo_id);
                if ($hd_msg["success"] !== true) {
                    cancel_transaction();
                    return array("success" => false, "message" => $hd_msg['message']);
                }
                
            if ($process === true) {
                $ap_msg = approve_personal_material_return($pmrt_no);     
                    if ($ap_msg['success'] === false ) {
                        cancel_transaction();
                        return $ap_msg;
                    }
                    
                    $approval_status = $ap_msg['approval_status']; // this approval status is used by below functions.
            }
                
            $sv_ln_msg = save_personal_material_return_lines($issue_trans_no, $return_trans_no, $project_id, $_POST['loc_code'], $tran_date, $process, $approval_status, 
                                                             $_POST['employee_code']);
                if ($sv_ln_msg['success'] !== true) {
                    cancel_transaction();
                    return $sv_ln_msg;       
                }
                
            // save personal material issue - return alloc, return qty => this shold be called after lines saving becouse it checks with approval status
            $sv_tr_rt_qty = save_personal_material_issue_lines_return_alloc_return_qty_total($issue_type, $issue_trans_no);
                if ($sv_tr_rt_qty['success'] !== true) {
                    cancel_transaction();
                    return $sv_tr_rt_qty;
                }
            
            if ($process === true && $approval_status == AS_APPROVED) {
                // budget update 
                $pmrt_details_array = $b = array();

                $result_2 = get_job_material_issue_details($return_trans_no, $type);      
                    while ($row = db_fetch($result_2)) {
                        $qty = $row['qty'];
                        $b['row_id'] = $row['trans_id'];
                        $b['stock_id'] = $row['stock_id'];
                        $b['task_id'] = $row['task_id'];
                        $b['requested_qty'] = $row['qty'];
                        $b['high_value_item'] = 0;

                        $standard_cost = $row['standard_cost'];
                        $b['reference_cost'] = $standard_cost; 
                        $b['standard_cost'] = $standard_cost;
                        $b['charging_cost'] = $standard_cost;
                        $b['total_issued_qty'] = $qty;
                        $b['qty'] = $qty;

                        $pmrt_details_array[] = $b;
                    }

                $mrt_tasks_summary = calculate_task_remaining_totals($pmrt_details_array);
                $created_by = $_SESSION['wa_current_user']->user;

                $mtrec_msg = remove_costs_from_tasks($type, $return_trans_no, $mrt_tasks_summary, $created_by);
                    if ($mtrec_msg['success'] !== true) {
                        cancel_transaction();
                        return array("success" => $mtrec_msg['success'], "message" => $mtrec_msg['message']);
                    }
            }
            
            // return qty + return alloc qty - returned qty
            $fully_return = check_all_personal_material_transfer_lines_fully_processed($issue_type, $issue_trans_no);
                if ($fully_return === true && $pm_issue_ap === AS_APPROVED) {
                    $ds_msg = direct_update_document_status($issue_type, $issue_trans_no, AS_COMPLETED, $issue_row_state);     
                        if ($ds_msg['success'] === false ) {
                            cancel_transaction();
                            return array("success" => false, "message" => "Could not update ".$systypes_array[$issue_type]." approval status.");
                        }

                        $issue_row_state = db_new_row_state($issue_row_state);
                } elseif ($fully_return === false && $pm_issue_ap === AS_COMPLETED) {
                    $ds_msg = direct_update_document_status($issue_type, $issue_trans_no, AS_APPROVED, $issue_row_state);     
                        if ($ds_msg['success'] === false ) {
                            cancel_transaction();
                            return array("success" => false, "message" => "Could not update ".$systypes_array[$issue_type]." approval status.");
                        }

                        $issue_row_state = db_new_row_state($issue_row_state);
                }
                
            $rtn_af = update_job_material_issue_row_state_by_id($pmi_no, $issue_row_state);
                if (! ($rtn_af > 0)) {
                    cancel_transaction();
                    return array("success" => false, "message" => "Could not update ".$systypes_array[$issue_type]." record #$pmi_no row state.");
                }
                
        commit_transaction();
            
            if ($process === true) {
                set_session_variable('pmrt_messages', $ap_msg['message']);
                meta_forward($_SERVER['PHP_SELF'], "type=$type&ProcessedID=$return_trans_no"); 
            } else {
                return array("success" => true, "message" => $systypes_array[$type]." trans #$return_trans_no has been saved.");
            }
}

function can_save_new_personal_material_return_line() {
    if (! ($_POST['item_type'] > 0)) {
        return array("success" => false, "focus_to" => "item_type", "message" => "Please select an item type.");  
    }
    
    if (in_array($_POST['item_type'], array(NSIT_NON_STOCK_ITEM, NSIT_STOCK_ITEM))) {
        if (! (strlen($_POST['stock_id']) > 0)) {
            return array("success" => false, "focus_to" => "stock_id", "message" => "Please select an item.");  
        }

        if ($_POST['tran_unit'] == -1) {
            return array("success" => false, "focus_to" => "tran_unit", "message" => "Please select a tran unit.");  
        }
    } elseif ($_POST['item_type'] == NSIT_COMMENT) {
        if (! (strlen($_POST['item_description']) > 0)) {
            return array("success" => false, "focus_to" => "item_description", "message" => "Item description cannot be empty.");  
        }
        
        if ($_POST['tran_unit'] == '0') {
            return array("success" => false, "focus_to" => "tran_unit", "message" => "Please select a tran unit.");  
        }
    }
    
    $item = get_stock_item_edit_info($_POST['stock_id']);
        if ($_POST['item_type'] == NSIT_NON_STOCK_ITEM){
            if (! ($item['mb_flag'] == "D")) {
                return array("success" => false, "focus_to" => "stock_id", "message" => "Selected item is a stock item, Please select a non-stock item.");  
            } 
        } elseif ($_POST['item_type'] == NSIT_STOCK_ITEM){
            if (! in_array($item['mb_flag'], array("B", "M"))) {
                return array("success" => false, "focus_to" => "stock_id", "message" => "Selected item is not a stock item, Please select a stock item.");  
            } 
        }
    
    if (! ($_POST['tran_qty'] > 0)) {
        return array("success" => false, "focus_to" => "tran_qty", "message" => "Quantity should be greater than zero.");  
    }
    
    if ($_POST['item_type'] == NSIT_NON_STOCK_ITEM) {
        if (! ($_POST['item_cost'] > 0)) {
            return array("success" => false, "focus_to" => "item_cost", "message" => "Item cost should be greater than zero.");  
        }
    }

        return array("success" => true, "focus_to" => '', "message" => "");  
}

function approve_personal_material_return($pmrt_no) {
    $current_user_id = $_SESSION['wa_current_user']->user;
    $task_costs = 0;
    
    $header = get_job_material_issue_header_record($pmrt_no);
    
        return approve_document($header['type'], $header['trans_no'], $header['project_id'], $task_costs, $header['next_approval_group_id'], $current_user_id, 
                                $header['row_state'], $header['created_by']);
}

function process_personal_material_return_line($type, $trans_no, $tran_date, $project_id, $return_line_id, $stock_control_method, $employee_code) {
    $row = get_job_material_issue_details_line_by_type_trans_no_line_no($type, $trans_no, $return_line_id);
            
        $mns_stk_mv_msg = process_personal_material_return_item($trans_no, $type, $tran_date, $project_id, $row, $row['loc_code'], $employee_code);
            if ($mns_stk_mv_msg['success'] === false) {
                cancel_transaction();
                return $mns_stk_mv_msg;
            }
            
        // lot move
        if ($stock_control_method == SKCM_LOTS) {
            $lot_mv_msg = lot_allocations_to_lot_moves($type, $trans_no, $return_line_id);
                if ($lot_mv_msg['success'] === false) {
                    cancel_transaction();
                    return $lot_mv_msg;
                }
                
            $lot_loc_array = $lot_mv_msg['lot_loc_array'];
            
            // update lot balances
            $lot_bl_msg = save_lot_balances_from_array($lot_loc_array);
                if ($lot_bl_msg['success'] === false) {
                    cancel_transaction();
                    return $lot_bl_msg;
                }
        }

        return array("success" => true, "message" => "");
}

function process_personal_material_return_item($trans_no, $type, $tran_date, $project_id, $row, $loc_code, $employee_code='') {
    $tran_date_ = sql2date($tran_date);
    $qty = abs($row["qty"]);
    $tran_qty = abs($row["tran_qty"]);
    
    $standard_cost = $row["standard_cost"];
    
        // update stock moves
        if ($row['mb_flag'] == 'B' || $row['mb_flag'] == 'M') {
            $m = add_stock_adjustment_item($trans_no, $row["stock_id"], $row["loc_code"], $tran_date_, $row["reference"], $qty, $standard_cost, '', $row["tran_unit"], 
                                           $tran_qty, $row["conversion_factor"], $type, $row["task_id"], $row["project_site_id"], $row["trans_id"], $project_id);
        } else {
            $m = add_non_stock_move($type, $row["stock_id"], $trans_no, $row["loc_code"], $tran_date_, $row["reference"], $qty, $standard_cost, '', $row["visible"], 
                                    $row["price"], $row["discount_percent"], $row["tran_unit"], $tran_qty, $row["conversion_factor"], $row["task_id"], $row["project_site_id"], 
                                    $row["trans_id"], $row["item_description"], $project_id);
        }
        
            if (! ($m > 0)) {
                return array("success" => false, "message" => "Could not create the stock movement record for line id : ".$row["trans_id"]);
            }
    
        // update personal stock moves
        if (strlen($employee_code) > 2) {
            if ($row['mb_flag'] == 'B' || $row['mb_flag'] == 'M') {
                $n = add_personal_stock_move($type, $row["stock_id"], $trans_no, $loc_code, $tran_date_, $row["reference"], $qty, $standard_cost, 0, 1, 0, 0, '', 
                                             $row["tran_unit"], $tran_qty, $row["conversion_factor"], $row["task_id"], $row["project_site_id"], $row["trans_id"], 
                                             $project_id, $employee_code);
            } else {
                $n = add_personal_non_stock_move($type, $row["stock_id"], $trans_no, $loc_code, $tran_date_, $row["reference"], $qty, $standard_cost, '', $row["visible"], 
                                                 $row["price"], $row["discount_percent"], $row["tran_unit"], $tran_qty, $row["conversion_factor"], $row["task_id"], 
                                                 $row["project_site_id"], $row["trans_id"], $row["item_description"], $project_id, $employee_code);
            }
        }

            if (! ($n > 0)) {
                return array("success" => false, "message" => "Could not create the personal stock movement record for return line #".$row["trans_id"]);
            }

        return array("success" => true, 'trans_no' => $trans_no, "message" => "");            
}

function can_reject_back_to_originator_personal_material_return($pmrt_no, $trans_tp_name, $reject) {
    $hd_row = get_job_material_issue_header_record($pmrt_no);
    
        if (! is_array($hd_row)) {
            return array("success" => false, "message" => "Could not find $trans_tp_name #$pmrt_no.");
        }

        if (! isset($hd_row['type']) || $hd_row['type'] != ST_PERSONAL_MATERIAL_RETURN) {
            return array("success" => false, "message" => "Invalid transaction type.");
        }
        
        if ($reject === true) {
            if (! in_array($hd_row['approval_status'], array(AS_NEW, AS_AWAITING_APPROVAL, AS_BACK_TO_ORIGINATOR, AS_WITH_THE_APPROVER))) {
                return array("success" => false, "message" => "This document status does not allow to reject. Only unapproved records can be rejected.");
            }
        } else {
            if (! in_array($hd_row['approval_status'], array(AS_AWAITING_APPROVAL, AS_WITH_THE_APPROVER))) {
                return array("success" => false, "message" => "This document status does not allow to back to originator.");
            }
        }
        
        $ced_msg = can_edit_document(ST_PERSONAL_MATERIAL_ISSUE, $hd_row['project_id'], $hd_row['next_approval_group_id'], $_SESSION['wa_current_user']->user, 
                                     $hd_row['created_by']);
            if ($ced_msg['success'] !== true) {
                return array("success" => false, "message" => $ced_msg['message']);
            }
        
        return array("success" => true, "message" => "", "hd_row" => $hd_row);
}

function reject_personal_material_return($pmi_no, $pmrt_no) {
    global $systypes_array;
    
    $issue_type = ST_PERSONAL_MATERIAL_ISSUE;
    $type = ST_PERSONAL_MATERIAL_RETURN;
    $trans_tp_name = $systypes_array[$type];
    
    $cn_rej = can_reject_back_to_originator_personal_material_return($pmrt_no, $trans_tp_name, true);
        if ($cn_rej["success"] !== true) { 
            return $cn_rej;
        } 
        
        $hd_row = $cn_rej["hd_row"];
            $return_trans_no = $hd_row["trans_no"];
            $row_state = $hd_row["row_state"];
        
        $issue_hd_row = get_job_material_issue_header_record($pmi_no);
            $issue_row_state = $issue_hd_row['row_state'];
            $issue_trans_no = $issue_hd_row["trans_no"];
            $pm_issue_ap = $issue_hd_row["approval_status"];
        
        begin_transaction();
            
            $rj_msg = reject_document($type, $return_trans_no, $hd_row['project_id'], $hd_row['next_approval_group_id'], $_SESSION['wa_current_user']->user, $row_state);
                if ($rj_msg['success'] !== true) {
                    cancel_transaction();
                    return array("success" => false, "message" => $rj_msg['message']);
                }
            
            // save personal material issue - return alloc, return qty => this shold be called after lines saving becouse it checks with approval status
            $sv_tr_rt_qty = save_personal_material_issue_lines_return_alloc_return_qty_total($issue_type, $issue_trans_no);
                if ($sv_tr_rt_qty['success'] !== true) {
                    cancel_transaction();
                    return $sv_tr_rt_qty;
                }
                
            // return qty + return alloc qty - returned qty
            $fully_return = check_all_personal_material_transfer_lines_fully_processed($issue_type, $issue_trans_no);
                if ($fully_return === true && $pm_issue_ap === AS_APPROVED) {
                    $ds_msg = direct_update_document_status($issue_type, $issue_trans_no, AS_COMPLETED, $issue_row_state);     
                        if ($ds_msg['success'] === false ) {
                            cancel_transaction();
                            return array("success" => false, "message" => "Could not update ".$systypes_array[$issue_type]." approval status.");
                        }

                        $issue_row_state = db_new_row_state($issue_row_state);
                } elseif ($fully_return === false && $pm_issue_ap === AS_COMPLETED) {
                    $ds_msg = direct_update_document_status($issue_type, $issue_trans_no, AS_APPROVED, $issue_row_state);     
                        if ($ds_msg['success'] === false ) {
                            cancel_transaction();
                            return array("success" => false, "message" => "Could not update ".$systypes_array[$issue_type]." approval status.");
                        }

                        $issue_row_state = db_new_row_state($issue_row_state);
                }
                
            $rtn_af = update_job_material_issue_row_state_by_id($pmi_no, $issue_row_state);
                if (! ($rtn_af > 0)) {
                    cancel_transaction();
                    return array("success" => false, "message" => "Could not update ".$systypes_array[$issue_type]." record #$pmi_no row state.");
                }
            
        commit_transaction();

            set_session_variable('pmrt_rj_messages', $rj_msg['message']);
            meta_forward($_SERVER['PHP_SELF'], "type=$type&RejectedID=$return_trans_no"); 
}

function back_to_originator_personal_material_return($pmrt_no) {
    global $systypes_array;
    
    $type = ST_PERSONAL_MATERIAL_RETURN;
    $trans_tp_name = $systypes_array[$type];
    
    $cn_rej = can_reject_back_to_originator_personal_material_return($pmrt_no, $trans_tp_name, false);
        if ($cn_rej["success"] !== true) { 
            return $cn_rej;
        } 
        
        $hd_row = $cn_rej["hd_row"];
        $trans_no = $hd_row["trans_no"];
        
        begin_transaction();
        
            $ap_msg = send_back_to_document_originator($type, $trans_no, $hd_row['project_id'], $hd_row['next_approval_group_id'], $_SESSION['wa_current_user']->user, 
                                                       $hd_row['row_state'], $hd_row['created_by']);
                if ($ap_msg['success'] === false ) {
                    cancel_transaction();
                    return array("success" => false, "message" => $ap_msg['message']);
                }
            
        commit_transaction();

            set_session_variable('pmrt_bo_messages', $ap_msg['message']);
            meta_forward($_SERVER['PHP_SELF'], "type=$type&BackedOrgID=$trans_no"); 
}

function view_personal_material_return_header($type, $trans_no) {
    global $approval_statuses;
    
    $row = get_job_material_issue_header_type_trans_no($type, $trans_no);
    
    $user_id = $_SESSION['wa_current_user']->user;
    $cap = can_access_project($row['project_id'], $user_id);
    if ($cap['success'] !== true) {
        display_error($cap["message"]);
        display_footer_exit();
        exit;
    }
    
        start_outer_table(TABLESTYLE2, "width=70%");

            table_section(1, "50%");
                $re_hd = get_job_material_issue_header_record($row['jmr_no']);
                label_row("Issue Trans #:", get_inventory_trans_view_str(ST_PERSONAL_MATERIAL_ISSUE, $re_hd['trans_no']), "class='tableheader2'");  
                $jo_id = $row['jo_id'];
                label_row("Job Card #:", get_service_trans_view_str(ST_JOB_ORDER, $jo_id), "class='tableheader2'");
                label_row(_("Reference:"), $row['reference'], "class='tableheader2'");
                label_row(_("Date:"), sql2date($row['tran_date']), "class='tableheader2'");

            table_section(2, "50%");
                label_row(_("Project:"), get_project_formatted_name($row['project_id']), "class='tableheader2'");
                label_row(_("Location:"), $row['location_name'], "class='tableheader2'");
                label_row(_("Employee:"), get_employee_formatted_long_name($row['employee_code']), "class='tableheader2'");
                $s = get_project_trans_view_str(ST_APPROVAL_LOG, $trans_no."&source_type_id=".$type, "Approval Status");
                label_row($s, $approval_statuses[$row['approval_status']], "class='tableheader2'");

        end_outer_table(2);

        if (strlen($row['comments']) > 0) {
            start_table(TABLESTYLE2);
                label_row(_("Comment:"), nl2br($row['comments']), "class='tableheader2'");
            end_table(2);
        }
}

function view_personal_material_return_details($type, $trans_no) {
    global $daily_item_types_array;
    
    $view_tp = ST_LOT_ALLOCATION;
    $hd_row = get_job_material_issue_header_record_type_trans_no($type, $trans_no);
        if (in_array($hd_row['approval_status'], array(AS_APPROVED))) {
            $view_tp = ST_LOT_MOVE;
        }
        
    $user_id = $_SESSION['wa_current_user']->user;
    $cap = can_access_project($hd_row['project_id'], $user_id);
    if ($cap['success'] !== true) {
        display_error($cap["message"]);
        display_footer_exit();
        exit;
    }
    
    start_table(TABLESTYLE, "width=90%");

        $th = array(_("Line Id"), _("Issue.Ln"), _("Item Type"), _("Description"), _("Unit"), _("Tran Qty"), _("Budget"), _('Unit Price'), _('Project Site'), _('Comment'));  
        table_header($th);

        $k = 0; //row colour counter
            $result = get_job_material_issue_details($trans_no, $type);      
                while ($row = db_fetch($result)) {
                    $dec = 4;
                    
                    alt_table_row_color($k);

                        $trans_id = $row['trans_id'];
                        $source_line_id = $row['source_line_id'];
                        
                        if ($row['stock_control_method'] == SKCM_LOTS) {
                            $params = "type=".ST_PERSONAL_MATERIAL_RETURN."&trans_no=$trans_no&line_id=$trans_id";
                            label_cell(get_data_view_str($view_tp, $params, $trans_id), 'align=center');
                        } else {
                            label_cell($trans_id, 'align=center');
                        }
                        label_cell($source_line_id, 'align=center');
                        
                        label_cell($daily_item_types_array[$row['item_type']]);
                        if ($row['item_type'] == NSIT_NON_STOCK_ITEM || $row['item_type'] == NSIT_STOCK_ITEM) {
                            label_cell($row["stock_id"]." - ".$row["item_description"]);  
                            
                            $dec = get_qty_dec($row["stock_id"]);
                        } else {
                            label_cell($row["item_description"]);
                        }
                        label_cell($row["unit_name"]);
                        
                        if ($row['stock_control_method'] == SKCM_LOTS) {
                            $params = "type=".ST_PERSONAL_MATERIAL_RETURN."&trans_no=$trans_no&line_id=$trans_id";
                            label_cell(get_data_view_str($view_tp, $params, number_format($row["tran_qty"], $dec)), 'align=right');
                        } else {
                            qty_cell($row["tran_qty"], false, $dec);
                        }
                        
                        label_cell($row['task_description']);

                        $tran_unit_cost = $row["conversion_factor"] * $row["standard_cost"];
                            if ($tran_unit_cost > 0) {
                                qty_cell($tran_unit_cost, false, $dec);
                            } else {
                                label_cell('');
                            }
                            
                        label_cell($row["site_description"]);          
                        label_cell(nl2br($row["line_comment"]));          

                    end_row();        
                }

    end_table(2);
}

function view_personal_material_return_headers_by_pmi_no($pmi_no) {
    $result = get_job_material_issue_headers_by_jmr_no_type($pmi_no, ST_PERSONAL_MATERIAL_RETURN); 
        if (! (db_num_rows($result) > 0)) {
            return;
        }
        
    $jo_row = get_job_material_issue_header_record($pmi_no);
    $user_id = $_SESSION['wa_current_user']->user;
    $cap = can_access_project($jo_row['project_id'], $user_id);
        if ($cap['success'] !== true) {
            display_error($cap["message"]);
            display_footer_exit();
            exit;
        }
    
    global $approval_statuses;
    
        start_table(TABLESTYLE, "width=80%");

            $th = array(_("Trans #"), _("Trans Date"), _("Employee"), _("Location"), _("Approval Status"));  
            table_header($th);

            $k = 0; //row colour counter
                while ($row = db_fetch($result)) {
                    alt_table_row_color($k);
                        label_cell(get_inventory_trans_view_str($row['type'], $row['trans_no']), 'align=center');
                        label_cell(sql2date($row["tran_date"]), 'align=center');
                        label_cell(get_employee_formatted_long_name($row["employee_code"]));
                        label_cell($row['location_name']);
                        label_cell($approval_statuses[$row['approval_status']], 'align=center');
                    end_row();        
                }

        end_table(2);
}

?>